## 5.1

ages <- list(25, 35, 45)

for( age in ages ) {
    print( age )
}

## 5.4

list_of_numbers <- list( 5, 10, 50, 200 )

for( item in list_of_numbers ) {
    times_two <- item * 2
    print( times_two )
}

## 5.5

for( number in 0:10 ) {
    print( 7 * number )
}

## 5.6

list_of_numbers <- list( 25, 35, 45 )
sum_gatherer <- 0

for( number in list_of_numbers ) {
    sum_gatherer <- sum_gatherer + number
}
    
print( sum_gatherer )

## 5.7

list_of_numbers <- list( 25, 35, 45 )
sum_gatherer <- 0
n <- 0

for( number in list_of_numbers ) {
    sum_gatherer <- sum_gatherer + number
    n <- n + 1
}
    
print( sum_gatherer / n )

## 5.8

ages <- list(
    'person1' = 25,
    'person2' = 35,
    'person3' = 45
)

for( name in names( ages ) ) {
    age <- ages[[name]]
    print( paste( name, age ) )
}

## 5.10

english_to_finnish <- list(
    'i' = 'minä',
    'you' = 'sinä',
    'social' = 'sosiaalinen',
    'science' = 'tiede',
    'needs' = 'tarvitsee',
    'programming' = 'ohjelmointi',
    'skills' = 'taidot'
)

sentence_to_translate = 'social science needs programming skills'
translated_sentence = ''

for( word in strsplit( sentence_to_translate, ' ') [[1]] ) {
    translated_word <- english_to_finnish[[ word ]]
    translated_sentence <- paste( translated_sentence, translated_word )
}

print( paste ( sentence_to_translate, 'in Finnish is', translated_sentence ) )

## 5.11

english_to_finnish <- list(
    'i' = 'minä',
    'you' = 'sinä',
    'social' = 'sosiaalinen',
    'science' = 'tiede',
    'needs' = 'tarvitsee',
    'programming' = 'ohjelmointi',
    'skills' = 'taidot'
)

sentence_to_translate = 'i love you'
translated_sentence = ''

for( word in strsplit( sentence_to_translate, ' ') [[1]] ) {
    if( word %in% names( english_to_finnish ) ) {
        translated_word <- english_to_finnish[[ word ]]
        translated_sentence <- paste( translated_sentence, translated_word )        
    } else {
        translated_sentence <- paste( translated_sentence, '[unknown]' )  
    }
}

print( paste ( sentence_to_translate, 'in Finnish is', translated_sentence ) )

## 5.12

degree <- list()

data <- read.csv('network.txt', sep = '-' )

for( line in 1:nrow(data) ) {
    node1 <- data[line, 1]
    node2 <- data[line, 2]
    
    if( ! node1 %in% names( degree ) ) {
        degree[node1] <- 0
    }
    
    if( ! node2 %in% names( degree ) ) {
        degree[node2] <- 0
    }
    
    degree[node1] <- degree[[node1]] + 1
    degree[node2] <- degree[[node2]] + 1
}


print( degree )

## 5.13

occurances <- list() ## this is the mega gatherer

data <- read.csv('numbers.txt', header = FALSE )

for( linenumber in 1:nrow(data) ) {
    number <- as.character( data[ linenumber, 1 ] ) ## operating numbers as text clarifies this code a bit
    if( ! number %in% names(occurances) ) {
        occurances[number] <- 0
    }
    occurances[number] <- occurances[[number]] + 1
}
    
print( occurances )

## 5.14

connections <- list()

data <- read.csv('pairs.txt', sep = ',', header = FALSE )

for( line in 1:nrow(data) ) {
    node1 <- data[line, 1]
    node2 <- data[line, 2]
    
    if( ! node1 %in% names( degree ) ) {
        connections[[node1]] <- c() ## i.e., en empty list
    }
    connections[[node1]] <- c( connections[[node1]] , node2 )
    
    if( ! node2 %in% names( degree ) ) {
        connections[node2] <- c() ## i.e., en empty list
    }
    connections[[node2]] <- c( connections[[node2]] , node1 )
    
}

print( connections )

## 5.19

all_votes <- list() ## collect all votes into a list

data <- read.csv("elections.txt", header = FALSE )
    
for( i in 1:nrow(data) ) {
    name <- data[i, 1]
    party <- data[i, 2]
    votes <- data[i, 3]
    birth_year <- data[i, 4]
    
    all_votes <- c( all_votes, votes )
}  
            
print( paste( "Number of candidates", length( all_votes ) ) ) 

## compute mean
sum_gatherer <- 0

for( number in all_votes ) {
    sum_gatherer <- sum_gatherer + number
}
    
print( sum_gatherer / length( all_votes) )

## 5.20

votes_per_party <- list() ## collect all votes into a list

data <- read.csv("elections.txt", header = FALSE )
    
for( i in 1:nrow(data) ) {
    name <- data[i, 1]
    party <- data[i, 2]
    votes <- data[i, 3]
    birth_year <- data[i, 4]
    
    if( ! party %in% names( votes_per_party ) ) {
        votes_per_party[[ party ]] <- 0
    }
    
    votes_per_party[[ party ]] <- votes_per_party[[ party ]] + votes
}  

print( votes_per_party )

## 5.21

candidates_per_party <- list()

data <- read.csv("elections.txt", header = FALSE )
    
for( i in 1:nrow(data) ) {
    name <- data[i, 1]
    party <- data[i, 2]
    votes <- data[i, 3]
    birth_year <- data[i, 4]
    
    if( ! party %in% names( candidates_per_party ) ) {
        candidates_per_party[[ party ]] <- 0
    }
    
    candidates_per_party[[ party ]] <- candidates_per_party[[ party ]] + 1
}  

print( candidates_per_party )

## 5.22

votes_per_party <- list() ## collect all votes into a list

data <- read.csv("elections.txt", header = FALSE )
    
for( i in 1:nrow(data) ) {
    name <- data[i, 1]
    party <- data[i, 2]
    votes <- data[i, 3]
    birth_year <- data[i, 4]
    
    if( ! party %in% names( votes_per_party ) ) {
        votes_per_party[[ party ]] <- c()
    }
    
    votes_per_party[[ party ]] <- c( votes_per_party[[ party ]] , votes )
}

for( party in names( votes_per_party ) ) {
    votes <- votes_per_party[[party]]
    votes <- sort( votes )
    print( paste( party, votes[length(votes)] ) )
}

## these variables are counted in previous exercises

mean_across_parties <- sum_gatherer / length(all_votes)

elected_candidates <- 0

data <- read.csv("elections.txt", header = FALSE )
    
for( i in 1:nrow(data) ) {
    name <- data[i, 1]
    party <- data[i, 2]
    votes <- data[i, 3]
    birth_year <- data[i, 4]
    
    if( votes >  2 * mean_across_parties ) {
        elected_candidates = elected_candidates + 1
    }
}     
       
print( elected_candidates )

## these variables are counted in previous exercises

mean_across_parties <- sum_gatherer / length(all_votes)

elected_candidates_per_party <- list()

data <- read.csv("elections.txt", header = FALSE )
    
for( i in 1:nrow(data) ) {
    name <- data[i, 1]
    party <- data[i, 2]
    votes <- data[i, 3]
    birth_year <- data[i, 4]
    
    if( votes >  2 * mean_across_parties ) {
        if( ! party %in% names(elected_candidates_per_party) ) {
            elected_candidates_per_party[[party]] <- 0
        }
        elected_candidates_per_party[[party]] <- elected_candidates_per_party[[party]] + 1
    }
}     
       
print( elected_candidates_per_party )

## 5.25

words <- list()
unique_words <- 0

data <- readLines( file('candidates_tweets.txt') )

for( rn in 1:length(data) ) {
    line <- tolower( data[[ rn ]] )
    line <- gsub(".", "", data[[ rn ]] ) ## cleaning the data sligtly by removing . and ,
    line <- gsub(",", "", data[[ rn ]] ) 
    for( word in strsplit( line, " ")[[1]] ) {
        if( ! word %in% words ) {
            words <- c( words, word )
            unique_words <- unique_words + 1
        }
    }
}

print( unique_words )

## 5.26

words <- list()

data <- readLines( file('candidates_tweets.txt') )

for( rn in 1:length(data) ) {
    line <- tolower( data[[ rn ]] )
    line <- gsub("\\.", "", line ) ## cleaning the data sligtly by removing . and ,
    line <- gsub(",", "", line ) 
    for( word in strsplit( line, " ")[[1]] ) { 
        word <- as.character( word )
        if( ! word %in% words ) {
            words[[ word ]] <- 0
        }
        words[[ word ]] <- words[[ word ]] + 1
    }
}

print( words )

## 5.27

print( names( words ) )

## frequencies of words
frequencies <- sort( unname(unlist( words ) ) )

most_common_10 <- frequencies[[length(frequencies)-9]] ## 10th most highest frequency

for( word in names(words) ) {
    frequency <- words[[word]]
    print( word )
    if( frequency >= most_common_10 ) {
        print( paste( word, frequency ) )
    }
}

## 5.28

data <- readLines( file('candidates_tweets.txt') )

for( rn in 1:length(data) ) {
    line <- tolower( data[[ rn ]] )
    line <- gsub(".", "", data[[ rn ]] ) ## cleaning the data sligtly by removing . and ,
    line <- gsub(",", "", data[[ rn ]] ) 
    
    words <- list()
    
    for( word in strsplit( line, " ")[[1]] ) {
        if( ! word %in% words ) {
            words[[ word ]] <- 0
        }
        words[[ word ]] <- words[[ word ]] + 1
    }
    
    print( words )
}


    
## removed ten most common

most_common_words <- list("RT", "a", "for", "to", "the", "of", "and", "that", "in", "is") ## from exercise 5.27; you could put them on list there

for( rn in 1:length(data) ) {
    line <- tolower( data[[ rn ]] )
    line <- gsub(".", "", data[[ rn ]] ) ## cleaning the data sligtly by removing . and ,
    line <- gsub(",", "", data[[ rn ]] ) 
    
    words <- list()
    
    for( word in strsplit( line, " ")[[1]] ) {
        if( ! word %in% most_common_words ) {
            if( ! word %in% words ) {
                words[[ word ]] <- 0
            }
            words[[ word ]] <- words[[ word ]] + 1
        }
    }
    
    print( words )
}

## 5.29

degrees <- list()

data <- read.csv('network.txt', sep = '-' )

for( rn in 1:nrow(data) ) {
    
    node1 <- data[ rn, 1]
    
    if( ! node1 %in% names(degrees) ) {
        degrees[[ node1 ]] <- 0
    }
    degrees[[ node1 ]] <- degrees[[ node1 ]] + 1
    
    node2 <- data[ rn, 2]
    
    if( ! node2 %in% names(degrees) ) {
        degrees[[ node2 ]] <- 0
    }
    degrees[[ node2 ]] <- degrees[[ node2 ]] + 1
    
}

for( node_name in names( degrees ) ) {
    degree_value <- degrees[[ node_name ]]
    print ( paste( node_name , 'has a degree of:', degree_value ) )
}

## 5.30

interested_nodes <- list('A', 'B', 'C')

data <- read.csv('network.txt', sep = '-' )

for( rn in 1:nrow(data) ) {
    
    node1 <- data[ rn, 1]
    node2 <- data[ rn, 2]
    
    if( node1 %in% interested_nodes && node2 %in% interested_nodes ) {
        print( paste( node1, node2 ) )
    }
}

## 5.31

edgelist <- list()

data <- read.csv('network.txt', sep = '-' )

for( rn in 1:nrow(data) ) {
    
    node1 <- data[ rn, 1]
    node2 <- data[ rn, 2]
    
    if( ! node1 %in% names( edgelist ) ) {
        edgelist[[node1]] <- list()
    }
    
    edgelist[[node1]] <- c( edgelist[[node1]], node2 )
    
}
    
print( edgelist )

## 5.32

nodes_visited <- list()
nodes_to_be_visited <- list('A')

while( length( nodes_to_be_visited ) > 0 ) {
    current_node <- nodes_to_be_visited[[1]]
    nodes_visited <- c( nodes_visited, current_node )
    connected_nodes <- edgelist[[ current_node ]] ## from exercise 5.31
    for( node in connected_nodes ) {
        if( ! node %in% nodes_visited && ! node %in% nodes_to_be_visited ) {
            nodes_to_be_visited <- c( nodes_to_be_visited , node )
        }
        nodes_to_be_visited <- nodes_to_be_visited[ nodes_to_be_visited != current_node ]
    }
}

print( unlist( nodes_visited ) )




