#!/usr/bin/env python
# coding: utf-8

# In[1]:


## 8.1

def fancy_print( text ):
    print("*****")
    print( text )
    print("*****")
    
fancy_print("Testing my fancy_print function")


# In[2]:


## 8.2

def my_function( number ):
    return 2 * number

print( my_function(3) )


# In[3]:


## 8.3

def largest_item( list_of_things ):
    largest = -1
    for item in list_of_things:
        if item > largest:
            largest = item
    return largest

print( largest_item( [1, 5, 4, 9, 14, 2 ] ) )


# In[4]:


## 8.4

def mathematics( x, y ):
    if x > y:
        return x * y - y
    else:
        return 2 * y - x


# In[5]:


## 8.5

def is_leap_year( year ):
    if year % 100 == 0:
        if year % 400 == 0: ## if it is divisible by 100, it is a leap year only if it can also be divided by 400.
            return True
        else:
            return False
    else:
        if year % 4 == 0: ## A year is a leap year if it can be divided by 4.
            return True
        else:
            return False


# In[6]:


## 8.6

## is_leap_year is defined in 8.5

def number_of_days( year1, year2 ):
    total_days = 0
    for year in range( year1, year2 ):
        if is_leap_year( year ):
            total_days = total_days + 366
        else:
            total_days = total_days + 365
    return total_days


# In[7]:


print( number_of_days(2023, 2024) )
print( number_of_days(2023, 2030) )


# In[8]:


## 8.7

import networkx

graph = networkx.read_edgelist("edgelist.txt")
print( graph.degree() )


# In[9]:


## 8.8

## This is an R-only exercise


# 8.9
# 
# - when factorial is set a 0 in the begining, the result is 0 (0 times anything is still zero)
# - the calculation factorial * current is not stored to any variable, thus the current stored in factorial does not work
# - printing factorial within the for-loop prints it many times

# 8.10
# 
# - the statement current = current + 1 does not make any sense and should be removed
# - the sum variable should increase the sum variable, not reset it - i.e. it should be sum = sum + current

# In[10]:


## 8.12

## define known leap years between 1900 and 2022

leap_years = [1904, 1908, 1912, 1916, 1920, 1924, 1928, 1932, 1936, 1940, 1944, 1948, 1952, 1956, 1960, 1964, 1968, 1972, 1976, 1980, 1984, 1988, 1992, 1996, 2000, 2004, 2008, 2012, 2016, 2020]

for potential_leap_year in leap_years:
    if is_leap_year ( potential_leap_year ) == False:
        print("Is leap year is not working correctly")
        
for year in range(1900, 2023):
    if year not in leap_years:
        if is_leap_year( year ) == True:
            print("Is leap year is not working correcty")
            
print("If nothing printed above, is leap year correctly identified leap years and not-leap-years between 1900 and 2022")


# In[11]:


## 8.13

def tax_rate( income, children ):
    taxes = 0.2 * income
    taxes = taxes - 10 * children
    if taxes < 0:
        taxes = 10
    return taxes

def tax_rate( income, children ):
    taxes = 0.2 * income
    if children > 0:
        taxes = 2/3 * taxes
    return taxes


# In[12]:


## 8.14

stockA = [100]
stockB = [100]

def inflowA( stockA, stockB ):
    increaseA = 0.05
    increaseA_B = 0.05
    return increaseA * stockA[-1] + increaseA_B * stockB[-1]

def outflowA( stockA, stockB ): ## while this does not use stockB, it might be better to make the function so that in case we use it, it is there
    decreaseA = 0.05
    return decreaseA * stockA[-1]

def inflowB( stockA, stockB ):
    increaseB = 0.05
    increaseB_A = 0.05
    return increaseB * stockB[-1] + increaseB_A * stockA[-1]

def outflowB( stockA, stockB ):
    decreaseB = 0.05
    return decreaseB * stockB[-1]

for i in range(0, 50):
    changeA = inflowA( stockA, stockB ) - outflowA( stockA, stockB )
    stockA.append( stockA[-1] + changeA )
    
    changeB = inflowB( stockA, stockB ) - outflowB( stockA, stockB )
    stockB.append( stockB[-1] + changeB )
    
print( stockA )
print( stockB )


# In[13]:


## 8.16

def sum( list_of_things ):
    sum = 0
    for thing in list_of_things:
        sum = sum + thing
    return sum

def mean( list_of_things ):
    return sum( list_of_things ) / len( list_of_things )

experimental = {}
experimental['A'] = []
experimental['B'] = []

for line in open('experiment.txt'):
    line = line.strip().split(',')
    condition = line[1]
    
    for i in range(2,6):
        experimental[ condition ].append( float( line[i] ) )
        
## means

print("Mean for A", mean( experimental['A'] ) )


# In[14]:


## 8.17

def make_science_happen( index ):
    
    conditionA = 0
    conditionB = 0
    
    for line in open('experiment.txt'):
        line = line.strip().split(',')
        condition = line[1]
        experimental_value = float( line[1+index] ) ## index 0 is for username, index 1 is for condition, thus starting from that
        
        if condition == 'A':
            conditionA = conditionA + experimental_value
        if condition == 'B':
            conditionB = conditionB + experimental_value
        
    if conditionA - conditionB > 1:
        return True
        
    return False

make_science_happen( 1 )


# In[ ]:




