## 8.1

fancy_print <- function( text ){
    print("*****")
    print( text )
    print("*****")
}
    
fancy_print("Testing my fancy_print function")

## 8.2

my_function <- function( number ){
    return( 2 * number )
}

print( my_function(3) )

## 8.3

largest_item <- function( list_of_things ) {
    largest <- -1
    for( item in list_of_things ) {
        if( item > largest ) {
            largest <- item
        }
    }
    return( largest )
}

print( largest_item( list(1, 5, 4, 9, 14, 2 ) ) )

## 8.4

mathematics <- function( x, y ) {
    if( x > y ) {
        return( x * y - y )
    } else {
        return( 2 * y - x )
    }
}

## 8.5

is_leap_year <- function( year ) {
    if( year %% 100 == 0 ){
        if( year %% 400 == 0 ) { ## if it is divisible by 100, it is a leap year only if it can also be divided by 400.
            return( TRUE )
        } else {
            return( FALSE )
        }
    } else {
        if( year %% 4 == 0 ) { ## A year is a leap year if it can be divided by 4.
            return( TRUE )
        } else {
            return( FALSE )
        }
    }
}

## 8.6

number_of_days <- function( year1, year2 ){
    total_days <- 0
    for( year in year1:(year2-1) ){
        if( is_leap_year( year ) ) {
            total_days <- total_days + 366
        } else {
            total_days <- total_days + 365
        }
    }
    return( total_days )
}

print( number_of_days(2023, 2024) )
print( number_of_days(2023, 2030) )

## 8.7

## this is a Python only exercise

## 8.8

dependent_variable_name <- 'V10'
independent_variables <- list('V4', 'V5', 'V6', 'V7', 'V8', 'V9')

dependent_data <- list()
independent_data <- list()

recode <- list( "1" = "Very happy",
    "2" = "Rather happy",
    "3" = "Not very happy",
    "4" = "Not at all happy"
)

data <- read.csv('wvs.csv')

for( rn in 1:nrow(data) ) {
    
    if( data[rn, 'V2'] == 752 ) {
        dependent_variable <-  data[rn, dependent_variable_name ]
        if( 1 <= dependent_variable ) { ## we want to check dependable data is OK, i.e. in range of accepted options
            
            dependent_data <- c( dependent_data , recode[[dependent_variable]] ) 
            
            dd <- list()
            for( variable in independent_variables ) {
                dd <- c( dd, data[rn, variable] )
            }
            
            independent_data <- c( independent_data , list( dd ) )
        }
    }
    
}

print( dependent_data )
print( independent_data )

## while a fun exercise, in R one usually does not need to operate on data in such low level
## caret allows doing equations with R and applying data frames (see Chapter 9 for more)
## so this would be more like this, but with much more data cleaning etc still required
## for example, limiting oneself to just country 752 (V2) is non part of the code here
## neither are missing values properly addressed

library('caret')
train( V10 ~ V4 + V5 + V6 + V7 + V8 + V9, data = data, methood = 'rpart')

## 8.12

## define known leap years between 1900 and 2022

leap_years = list( 1904, 1908, 1912, 1916, 1920, 1924, 1928, 1932, 1936, 1940, 1944, 1948, 1952, 1956, 1960, 1964, 1968, 1972, 1976, 1980, 1984, 1988, 1992, 1996, 2000, 2004, 2008, 2012, 2016, 2020 )

for( potential_leap_year in leap_years ) {
    if( is_leap_year ( potential_leap_year ) == FALSE ) {
        print("Is leap year is not working correctly")
    }
}
         
for( year in 1900:2023 ) {
    if( ! year %in% leap_years ) {
        if( is_leap_year( year ) == TRUE ) {
            print("Is leap year is not working correctly")
        }
    }
}
            
print("If nothing printed above, is leap year correctly identified leap years and not-leap-years between 1900 and 2022")

## 8.13

tax_rate <- function( income, children ) {
    taxes <- 0.2 * income
    taxes <- taxes - 10 * children
    if( taxes < 0 ) {
        taxes <- 10
    }
    return( taxes )
}
    

tax_rate <- function( income, children ) {
    taxes <- 0.2 * income
    if( children > 0 ) {
        taxes <- 2/3 * taxes
    }
    return( taxes )
}

## 8.14

stockA <- list(100)
stockB <- list(100)

inflowA <- function( stockA, stockB ) {
    increaseA <- 0.05
    increaseA_B <- 0.05
    return( increaseA * stockA[[length(stockA)]] + increaseA_B * stockB[[length(stockB)]] )
}
    
outflowA <- function( stockA, stockB ) { ## while this does not use stockB, it might be better to make the function so that in case we use it, it is there
    decreaseA <- 0.05
    return( decreaseA * stockA[[length(stockA)]] )
}

inflowB <- function( stockA, stockB ) {
    increaseB <- 0.05
    increaseB_A <- 0.05
    return( increaseB * stockB[[length(stockB)]] + increaseB_A * stockA[[length(stockA)]] )
}
    
outflowB <- function( stockA, stockB ) {
    decreaseB <- 0.05
    return( decreaseB * stockB[[length(stockB)]] )
}

for( i in 1:50 ) {
    changeA <- inflowA( stockA, stockB ) - outflowA( stockA, stockB )
    stockA <- c( stockA, stockA[[length(stockA)]] + changeA )
    
    changeB <- inflowB( stockA, stockB ) - outflowB( stockA, stockB )
    stockB <- c( stockB, stockB[[length(stockB)]] + changeB )
}
    
print( unlist(stockA) )
print( unlist(stockB) )

## 8.16

sum <- function( list_of_things ) {
    sum <- 0
    for( thing in list_of_things ){
        sum <- sum + thing
    }
    return( sum )
}

mean <- function( list_of_things ) {
    return( sum( list_of_things ) / length( list_of_things ) )
}
    
experimental <- list()
experimental[['A']] <- list()
experimental[['B']] <- list()

data <- read.csv("experiment.txt", header = FALSE )

for( rn in 1:nrow(data) ) {
    condition <- data[rn, 2]
    
    for( i in 3:7 ) {
        experimental[[condition]] <- c( experimental[[condition]], data[rn, i] )
    }
}

        
## means

print( paste("Mean for A", mean( experimental[['A']] ) ) )

## 8.17

make_science_happen <- function( index ) {
    
    conditionA <- 0
    conditionB <- 0
    
    data <- read.csv("experiment.txt", header = FALSE )

    for( rn in 1:nrow(data) ) {
        condition <- data[rn, 2]

        experimental_value = data[rn, index + 2] ## index 1 is user name, index 2 is condition, thus add two
        
        if( condition == 'A' ){
            conditionA <-  conditionA + experimental_value
        }    
        if( condition == 'B' ){
            conditionB <- conditionB + experimental_value
        }
        
    }
            
    if( conditionA - conditionB > 1 ){
        return( TRUE )
    }
        
    return( FALSE )

}

make_science_happen(1)


