#!/usr/bin/env python
# coding: utf-8

# In[17]:


## 9.1

import requests
from bs4 import BeautifulSoup

website_content = requests.get("http://codingsocialscience.org/").text

page = BeautifulSoup ( website_content , 'html.parser' )

for list in page.find_all('li'):
    print( list )


# In[16]:


## 9.2

import requests
from bs4 import BeautifulSoup

website_content = requests.get("https://uk.sagepub.com/").text

page = BeautifulSoup ( website_content , 'html.parser' )

image_count = 0

for image in page.find_all('img'):
    image_count = image_count + 1
    
print( image_count )


# In[18]:


## 9.3

import requests
from bs4 import BeautifulSoup

website_content = requests.get("https://www.helsinki.fi/").text
website_content = website_content.lower()

search_words = [ 'Twitter', 'Facebook', 'YouTube' ]

for search_word in search_words:
    if search_word.lower() in website_content:
        print("Found", search_word)


# In[21]:


## 9.4

import requests
from bs4 import BeautifulSoup

universities = ['https://www.helsinki.fi', 'https://www.aalto.fi']
results = {}

search_words = [ 'Twitter', 'Facebook', 'YouTube' ]

for university in universities:
    website_content = requests.get( university ).text
    website_content = website_content.lower()
    
    res = {} ## this is for storing service, count-pairs
    for search_word in search_words:
        res[ search_word ] = website_content.count( search_word.lower() )
        
    results[ university ] = res
    
print( results )


# In[35]:


## 9.5

if False: ## automated testing fails, so remove for now

    import requests
    from bs4 import BeautifulSoup

    start_url = "http://codingsocialscience.org/"

    start_page = requests.get( start_url ).text
    start_page = BeautifulSoup ( start_page , 'html.parser' )

    for link in start_page.find_all('a'):
        link = link['href']

        ## there are both internal and external links, for simplicity let's identify external links as those starting with http

        if link.startswith('http'):
            print( start_url + "-" + link )
            followup = requests.get( link ).text
            followup = BeautifulSoup( followup, 'html.parser' )

            for followuplink in followup.find_all('a'):
                followuplink = followuplink['href']
                if followuplink.startswith('http'):
                    print( link + "-" + followuplink )


# In[44]:


## 9.6

import requests
import json

url = 'https://data.police.uk/api/crimes-street/all-crime?lat=51.5073&lng=-0.171505' ## latest month is shown by default, see documentation
data = requests.get( url ).text ## could just be .json() for simplicyt, but doing here step by step
data = json.loads( data )

categories = {} ## this is a megacollector

for entry in data:
    
    category = entry['category']
    
    if category not in categories:
        categories[ category ] = 0
        
    categories[ category ] = categories[ category ] + 1
    

print( categories )


# In[53]:


## 9.7

import requests
import json

url = 'http://api.worldbank.org/v2/country/fi?format=json'
data = requests.get( url ).text ## could just be .json() for simplicyt, but doing here step by step
data = json.loads( data )

print( data[1][0]['capitalCity'] )


# In[61]:


## 9.8

import requests
import json

adjacents = ['se', 'no', 'ru', 'ee']

for country in adjacents:
    url = 'http://api.worldbank.org/v2/country/' + country + '?format=json'
    data = requests.get( url ).text ## could just be .json() for simplicy, but doing here step by step
    data = json.loads( data )

    print( data[1][0]['capitalCity'] )


# In[3]:


## 9.9

import requests
import json

url = 'http://api.worldbank.org/v2/country/all?format=json'
data = requests.get( url ).text ## could just be .json() for simplicy, but doing here step by step
data = json.loads( data )

## the book does not cover pagination, so let's this is not a full result

data = data[1] ## index 0 is for pagination details

for country in data:
    print( country['latitude'], country['longitude'], country['incomeLevel']['value'] )


# In[7]:


## 9.10

example = '127.0.0.1 - - [10/Nov/2020:08:43:18 +0200] "GET / HTTP/1.1" 200 4471 "-" "Mozilla/5.0"'
example = example.split('[')[1] ## everything to right from [
example = example.split(']')[0] ## everything to left from ]
## 10/Nov/2020:08:43:18 +0200 # you can print it out here
## print( example )
example = example.split(':')[0] ## everything left from :
date = example.split('/')
day = date[0]
month = date[1]
year = date[2]

print( year, month, day )


# In[8]:


## 9.11

from PyPDF2 import PdfReader

all_text = ''

reader = PdfReader('alice.pdf')
number_of_pages = len(reader.pages)


for i in range( number_of_pages ):
    page = reader.pages[i]
    text = page.extract_text()
    all_text = all_text + text
    
print( all_text )


# In[9]:


## 9.12

from docx import Document

all_text = ''

document = Document('alice.docx')

for paragraph in document.paragraphs:
    all_text = all_text + paragraph.text
    
print( all_text )


# In[10]:


## 9.13

import requests
from bs4 import BeautifulSoup

universities = ['https://www.helsinki.fi', 'https://www.aalto.fi']
results = {}

search_words = [ 'Twitter', 'Facebook', 'YouTube' ]

for university in universities:
    website_content = requests.get( university ).text
    website_content = website_content.lower()
    
    res = {} ## this is for storing service, count-pairs
    for search_word in search_words:
        res[ search_word ] = website_content.count( search_word.lower() )
        
    results[ university ] = res
    
import json

json.dump( results, open("universities.json", "w") )


# In[11]:


## 9.14

import json

data = json.load( open("universities.json") )

for university, results in data.items():
    counts = 0
    for service, count in results.items():
        counts = counts + count
    print( university, counts )


# In[17]:


## 9.15

import json

## this could also be a dictionary in dictionary
northwest = {}
northeast = {}
southwest = {}
southeast = {}

data = json.load( open("countries.json") )

for country in data:
    income = country['income']
    if country['lat'] > 0:
        if country['long'] > 0:
            if income not in northeast:
                northeast[ income ] = 0
            northeast[ income ] = northeast[ income ] + 1
        else:
            if income not in northwest:
                northwest[ income ] = 0
            northwest[ income ] = northwest[ income ] + 1
    if country['lat'] < 0:
        if country['long'] > 0:
            if income not in southeast:
                southeast[ income ] = 0
            southeast[ income ] = southeast[ income ] + 1
        else:
            if income not in southwest:
                southwest[ income ] = 0
            southwest[ income ] = southwest[ income ] + 1
            
print( northwest, northeast, southwest, southeast )


# In[26]:


## 9.16

import pandas

url = 'https://data.police.uk/api/crimes-street/all-crime?lat=51.5073&lng=-0.171505' ## latest month is shown by default, see documentation
dataframe = pandas.read_json(url)

## note: it is also possible to manually construct the dataframe if you wish and append, remove rows from it. this is a simple example to make it clear why one might want to use tools such as pandas

print( dataframe['category'].value_counts() )


# In[ ]:




